const {Client} = require("../../index");
const assert = require("assert/strict");

const client = new Client;

const actions = [
	() => client.set("x", 42, (success, details) => {
		console.log("set x:", success, details);
		assert.deepStrictEqual(success, true);
	}),

	() => client.get("x", (success, details) => {
		console.log("get x:", success, details);
		assert.deepStrictEqual(details, 42);
	}),

	() => client.resetCache("x", (success, details) => {
		console.log("resetCache x:", success, details);
		assert.deepStrictEqual(success, true);
	}),

	() => client.get("x", (success, details) => {
		console.log("get x:", success, details);
		assert.deepStrictEqual(success, false);
	}),

	() => client.set("x", 42, (success, details) => {
		console.log("set x:", success, details);
		assert.deepStrictEqual(success, true);
	}),

	() => client.get("x", (success, details) => {
		console.log("get x:", success, details);
		assert.deepStrictEqual(details, 42);
	}),

	() => client.remove("x", (success, details) => {
		console.log("remove x:", success, details);
		assert.deepStrictEqual(success, true);
	}),

	() => client.get("x", (success, details) => {
		console.log("get x:", success, details);
		assert.deepStrictEqual(success, false);
	})
];

const exec = () => {
	const action = actions.shift();
	action();
	if (actions.length) {
		setTimeout(exec, 2000);
	}
};

exec();
