const {Client} = require("../../index");
const assert = require("assert/strict");

const client = new Client;

const actions = [
	() => client.set("some_table/some_key_field_name/1/some_field_name", 42, (success, details) => {
		console.log("set x:", success, details);
		assert.deepStrictEqual(success, true);
	}),

	() => client.get("some_table/some_key_field_name/1/some_field_name", (success, details) => {
		console.log("get x:", success, details);
		assert.deepStrictEqual(details, 42);
	}),

	() => client.resetCache("some_table/some_key_field_name/1/some_field_name", (success, details) => {
		console.log("resetCache x:", success, details);
		assert.deepStrictEqual(success, true);
	}),

	() => client.get("some_table/some_key_field_name/1/some_field_name", (success, details) => {
		console.log("get x:", success, details);
		assert.deepStrictEqual(details, 42);
	}),

	() => client.remove("some_table/some_key_field_name/1/some_field_name", (success, details) => {
		console.log("remove x:", success, details);
		assert.deepStrictEqual(success, true);
	}),

	() => client.get("some_table/some_key_field_name/1/some_field_name", (success, details) => {
		console.log("get x:", success, details);
		assert.deepStrictEqual(success, false);
	}),

	() => client.set("some_table/some_key_field_name/2", {some_field_name: 43}, (success, details) => {
		console.log("set x:", success, details);
		assert.deepStrictEqual(success, true);
	}),

	() => client.get("some_table/some_key_field_name/2", (success, details) => {
		console.log("get x:", success, details);
		assert.deepStrictEqual(details, {some_field_name: 43});
	}),

	() => client.resetCache("some_table/some_key_field_name/2", (success, details) => {
		console.log("resetCache x:", success, details);
		assert.deepStrictEqual(success, true);
	}),

	() => client.get("some_table/some_key_field_name/2", (success, details) => {
		console.log("get x:", success, details);
		assert.deepStrictEqual(details, {some_key_field_name: 2, some_field_name: 43});
	}),

	() => client.remove("some_table/some_key_field_name/2", (success, details) => {
		console.log("remove x:", success, details);
		assert.deepStrictEqual(success, true);
	}),

	() => client.get("some_table/some_key_field_name/2", (success, details) => {
		console.log("get x:", success, details);
		assert.deepStrictEqual(success, false);
	})
];

const exec = () => {
	const action = actions.shift();
	action();
	if (actions.length) {
		setTimeout(exec, 2000);
	}
};

exec();
