const crypto = require("crypto");
const fs = require("fs");

const md5 = data => crypto.createHash("md5").update(data).digest("hex");

const md5ForFile = (fileName, onResult) => {
	const res = crypto.createHash("md5");
	const s = fs.createReadStream(fileName);
	s.on("data", chunk => {
		res.update(chunk);
	});
	s.on("end", () => {
		onResult(true, res.digest("hex"));
	});
	s.on("error", error => {
		onResult(false, "fs error " + error.toString());
	});
};

const rand = (min, max) => Math.floor(Math.random() * (max - min + 1)) + min;

module.exports = {md5, md5ForFile, rand};
